from textual.screen import Screen
from textual.widgets import Header, Footer, Static, Button
from textual.containers import Grid

from .show_controller import ShowController

# Screen[dict[int, str, int]]
class ShowDeleteScreen(Screen):

    CSS = """

    Grid {
        grid-size: 2;
        grid-rows: 2 auto;
        grid-columns: 30 auto;
        height: 100%;
        width: 100%;
        padding: 1;
    }

    Input {
        border: none;
    }
    Button {
        border: none;
    }
    #toplabel {
        height: 1;        
    }

    .two {
        column-span: 2;
    }

    .box {
        height: 100%;
        border: solid green;
    }
    """

    def __init__(self, showId = None):
        super().__init__()

        self.context = self.app.getContext()
        self.Session = self.context['database']['session'] # convenience

        self.__sc = ShowController(context = self.context)
        
        self.__showDescriptor = self.__sc.getShowDescriptor(showId) if showId is not None else {}


    def on_mount(self):
        if not self.__showDescriptor is None:
            self.query_one("#showlabel", Static).update(f"{self.__showDescriptor.getId()} - {self.__showDescriptor.getName()} ({self.__showDescriptor.getYear()})")


    def compose(self):

        yield Header()

        with Grid():

            yield Static("Are you sure to delete the following show?", id="toplabel", classes="two")

            yield Static("", classes="two")

            yield Static("", id="showlabel")
            yield Static("")

            yield Static("", classes="two")

            yield Static("", classes="two")

            yield Button("Delete", id="delete_button")
            yield Button("Cancel", id="cancel_button")


        yield Footer()


   # Event handler for button press
    def on_button_pressed(self, event: Button.Pressed) -> None:

        if event.button.id == "delete_button":

            if not self.__showDescriptor is None:
                if self.__sc.deleteShow(self.__showDescriptor.getId()):
                    self.dismiss(self.__showDescriptor)

            else:
                #TODO: Meldung
                self.app.pop_screen()

        if event.button.id == "cancel_button":
            self.app.pop_screen()
